/*      cscope - interactive C symbol cross-reference
 *
 *      preprocessor constant definitions
 */

#ifdef  uts
#define u370
#endif

#define ESC     '\033'          /* escape character */
#define MSGLEN  80              /* displayed message length */
#define NUMLEN  5               /* line number length */
#define PATHLEN 250             /* file pathname length */
#define PATLEN  80              /* symbol pattern length */
#define REFFILE "Cscope.out"    /* cross-reference output file */
#define READ    4               /* access(2) parameter */
#define WRITE   2               /* access(2) parameter */

/* scanner constants */
#define SYMBOLMAX       100     /* maximum symbols in a source line */
#define LINEMAX         350     /* maximum source line length */
#define TOKENMAX        30      /* maximum non-string token length */
#undef  YYLMAX          
#define YYLMAX          LINEMAX + TOKENMAX      /* scanner line buffer size */

/* cross-reference file mark characters (only significant after a tab char) */
#define DEFINE  '#'
#define FCNCALL '`'
#define FCNDEF  '$'
#define INCLUDE '~'
#define NEWFILE '@'

/* other scanner token types */
#define LEX_EOF 0
#define IDENT   2
#define KEYWORD 3
#define NEWLINE 4

/* screen lines */
#define FLDLINE (LI - FIELDS)   /* first input field line */
#define REFLINE 4               /* first displayed reference line */
#define MSGLINE 1               /* message line */
#define PRLINE  LI              /* input prompt line */

/* input fields (value matches field order on screen) */
#define SYMBOL          0
#define EDIT            1
#define CALLEDBY        2
#define CALLING         3
#define STRING          4
#define CHANGE          5
#define FILENAME        6
#define FIELDS          7
