/*      cscope - interactive C symbol cross-reference
 *
 *      file editing functions
 */

#include "global.h"

void    edit();

/* edit this displayed reference */

void
editref(i)
int     i;
{
        char    file[PATHLEN + 1];      /* file name */
        char    linenum[NUMLEN + 1];    /* line number */

        /* verify that there is a references found file */
        if (refsfound == NULL) {
                return;
        }
        /* get the selected line */
        seekline(i + topline);
        
        /* get the file name and line number */
        if (fscanf(refsfound, "%s%*s%s", file, linenum) == 2) {
                edit(file, linenum);    /* edit it */
        }
        seekline(topline);      /* restore the line pointer */
}
/* edit all references */

void
editall()
{
        char    file[PATHLEN + 1];      /* file name */
        char    linenum[NUMLEN + 1];    /* line number */

        /* verify that there is a references found file */
        if (refsfound == NULL) {
                return;
        }
        /* get the first line */
        seekline(1);
        
        /* get each file name and line number */
        while (fscanf(refsfound, "%s%*s%s%*[^\n]", file, linenum) == 2) {
                edit(file, linenum);    /* edit it */
        }
        seekline(topline);      /* restore the line pointer */
}
        
/* call the editor */

static void
edit(file, linenum)
char    *file;
char    *linenum;
{
        char    msg[MSGLEN + 1];        /* message */
        char    plusnum[NUMLEN + 2];    /* line number option */

        menucleanup();
        sprintf(msg, "%s +%s %s", basename(editor), linenum, file);
        putmsg(msg);
        sprintf(plusnum, "+%s", linenum);
#ifdef bogus
	/* I think this is bogus.  Why should emacs think you want to edit
	   /dev/null any more than vi?  The real solution is for cscope users
	   to work with "pagers" that know how to pause after a file without
	   giving them a bogus file to look at.  -- Tim 10-3-90 */
        if (strcmp(basename(editor), "vi") == 0) {
                execute(editor, editor, plusnum, file, 0);
        }
        else {  /* get the pager to pause after the file */
                execute(editor, editor, plusnum, file, "/dev/null", 0);
        }
#else bogus
	execute(editor, editor, plusnum, file, 0);
#endif bogus
        menuinit();             /* menu may be changed by editor */
}
