/*      cscope - interactive C symbol cross-reference
 *
 *      display help
 */

#include "global.h"

void
help()
{
        startbuffering();
        clearscreen();
        if (changing == NO) {
                if (mouse == YES) {
                        puts("Point with the mouse and click button 1 to move to the desired input field,\r");
                        puts("type the text to search for, and then press the RETURN key.\r");
                        puts("If the search is successful, you can edit the file containing a displayed line\r");
                        puts("by pointing with the mouse and clicking button 1.\r");
                        puts("\nYou can either use the button 2 menu or these single-character commands:\n\r");
                }
                else {
                        puts("Press the TAB key repeatedly to move to the desired input field,\r");
                        puts("type the text to search for, and then press the RETURN key.\r");
                        puts("If the search is successful, you can use these single-character commands:\n\r");
                        puts("1-9\t\tEdit the file containing the displayed line.\r");
                }
                puts("space bar\tDisplay next lines.\r");
                puts("+\t\tDisplay next lines.\r");
                puts("-\t\tDisplay previous lines.\r");
                puts("^E\t\tEdit all lines.\r");
                puts(">\t\tAppend all lines to a file.\r");
                if (mouse == NO) {
                        puts("\nAt any time you can use these single-character commands:\n\r");
                }
                puts(".\t\tSearch with the last text typed.\r");
                puts("^R\t\tRebuild the cross-reference.\r");
                puts("!\t\tStart an interactive shell (type ^D to return to cscope).\r");
                puts("^L\t\tRedraw the screen.\r");
                puts("?\t\tDisplay this list of commands.\r");
                puts("^D\t\tExit cscope.\r");
                puts("\nNote: If the first character of the text you want to search for matches\r");
                puts("a command, type a \\ character first.\r");
        }
        else {
                if (mouse == YES) {
                        puts("When changing text, point with the mouse and click button 1 to\r");
                        puts("mark or unmark the line to be changed.\r");
                        puts("\nYou can either use the button 2 menu or these single-character commands:\n\r");
                }
                else {
                        puts("When changing text, you can use these single-character commands:\n\r");
                        puts("1-9\t\tMark or unmark the line to be changed.\r");
                }
                puts("*\t\tMark or unmark all displayed lines to be changed.\r");
                puts("space bar\tDisplay next lines.\r");
                puts("+\t\tDisplay next lines.\r");
                puts("-\t\tDisplay previous lines.\r");
                puts("a\t\tMark all lines to be changed.\r");
                puts("^D\t\tChange the marked lines and exit.\r");
                puts("ESC\t\tExit without changing the marked lines.\r");
                puts("!\t\tStart an interactive shell (type ^D to return to cscope).\r");
                puts("^L\t\tRedraw the screen.\r");
                puts("?\t\tDisplay this list of commands.\n\r");
        }
        putchar('\n');
        stopbuffering();        /* BSD requires askforchar() to be after */
        askforchar();
        seekline(topline);
}
